# Touch Draggable

A very simple draggable implementation for tablet/mobile devices. It implement a tiny portion of the interface of the jquery-ui draggable widget, at least only the one I needed to make it works on one of my personal projects I was working on.

It does not have the entire power of the jquery-ui one, but since that required to simulate the mouse events and was moving top,left properties, on devices like iPad/iPhone the performance, was not that good, and that was a shame because those devices support hardware acceleration for other css properties.

So I'm completely sure the guys from jquery-ui will fix this very soon in the next upcoming version. For now I just want to share this tiny library in case anybody is interested :)

## Getting Started
Download the [production version][min] or the [development version][max].

[min]: https://raw.github.com/royriojas/touch-draggable/master/dist/touch-draggable.min.js
[max]: https://raw.github.com/royriojas/touch-draggable/master/dist/touch-draggable.js

In your web page:

```html
<script src="//ajax.googleapis.com/ajax/libs/jquery/1.7.2/jquery.min.js"></script>
<script src="//ajax.googleapis.com/ajax/libs/jqueryui/1.8.21/jquery-ui.min.js"></script>
<script src="dist/touch-draggable.js"></script>
<script>
$(function($) {
  $('.box.touch').touchDraggable();
});
</script>
```

## Documentation
_(Coming soon)_

Basically the handler option and the addClasses property is all that is implemented in this version.
That's all I need for now.

## Examples
check the demo folder, load it on a iOS device or a Android device with Jelly Bean to obtain the best performance!. The demo has the jquery UI draggable and this one so you can make a quick comparison.

## Release History
- version 0.0.1
First things added

## License
Copyright (c) 2012 Roy Riojas  
Licensed under the MIT, GPL licenses.

## Contributing
Feel free to do it!

### Important notes
Please don't edit files in the `dist` subdirectory as they are generated via grunt. You'll find source code in the `src` subdirectory!

While grunt can run the included unit tests via PhantomJS, this shouldn't be considered a substitute for the real thing. Please be sure to test the `test/*.html` unit test file(s) in _actual_ browsers.

### Installing grunt
_This assumes you have [node.js](http://nodejs.org/) and [npm](http://npmjs.org/) installed already._

1. Test that grunt is installed globally by running `grunt --version` at the command-line.
1. If grunt isn't installed globally, run `npm install -g grunt` to install the latest version. _You may need to run `sudo npm install -g grunt`._
1. From the root directory of this project, run `npm install` to install the project's dependencies.

### Installing PhantomJS

In order for the qunit task to work properly, [PhantomJS](http://www.phantomjs.org/) must be installed and in the system PATH (if you can run "phantomjs" at the command line, this task should work).

Unfortunately, PhantomJS cannot be installed automatically via npm or grunt, so you need to install it yourself. There are a number of ways to install PhantomJS.

* [PhantomJS and Mac OS X](http://ariya.ofilabs.com/2012/02/phantomjs-and-mac-os-x.html)
* [PhantomJS Installation](http://code.google.com/p/phantomjs/wiki/Installation) (PhantomJS wiki)

Note that the `phantomjs` executable needs to be in the system `PATH` for grunt to see it.

* [How to set the path and environment variables in Windows](http://www.computerhope.com/issues/ch000549.htm)
* [Where does $PATH get set in OS X 10.6 Snow Leopard?](http://superuser.com/questions/69130/where-does-path-get-set-in-os-x-10-6-snow-leopard)
* [How do I change the PATH variable in Linux](https://www.google.com/search?q=How+do+I+change+the+PATH+variable+in+Linux)
